//=============================================================================
// Copyright (C) 2023, Qorvo, Inc.
//
// THIS SOFTWARE IS SUBJECT TO A SOURCE CODE LICENSE AGREEMENT WHICH PROVIDES,
// AMONG OTHER THINGS:  (i) THAT IT CAN BE USED ONLY TO ADAPT THE LICENSEE'S
// APPLICATION TO PAC PROCESSORS SUPPLIED BY QORVO, INC.;
// (ii) THAT  IT IS PROVIDED "AS IS" WITHOUT WARRANTY;  (iii) THAT
// QORVO, INC. IS NOT LIABLE FOR ANY INDIRECT DAMAGES OR FOR DIRECT
// DAMAGES EXCEEDING US$1,500;  AND (iv) THAT IT CAN BE DISCLOSED TO AND USED
// ONLY BY CERTAIN AUTHORIZED PERSONS.
//
//=============================================================================

#ifndef PROJECT_VERSION_H
#define PROJECT_VERSION_H
#include "pac.h"

// version release state
#define PROJECT_VERSION_MAJOR           1
#define PROJECT_VERSION_MINOR           0
#define PROJECT_VERSION_BUGFIX          0
#define PROJECT_VERSION_RELEASE_STATE   PAC25XXX_RELEASED      // PAC25XXX_RELEASED, PAC25XXX_RC, PAC25XXX_BETA, PAC25XXX_ALPHA, PAC25XXX_IN_DEVELOPMENT
#define PROJECT_VERSION_RELEASE_NUM     0
#define PROJECT_VERSION_STR             "v1.0.0"

// Include Library Build Information - Includes Build Date and Time
#if defined(__ECLIPSE__) && defined(__GNUC__)  // Eclipse and GNU C Compiler
#include "project_build_info_eclipse.h"
#elif defined(__COIDE__) && defined __GNUC__   // CoIDE and GNU C Compiler
#include "project_build_info_coide.h"
#elif defined __ICCARM__            // IAR C Compiler
#include "project_build_info_iar.h"
#elif defined __CC_ARM              // Keil RealView C Compiler
#include "project_build_info_keil.h"
#else
#error No Project Build Info
#endif

#endif

/*============= Change Log  ===========================================================================================
===============================
PAC25xxx Example Code v1.0.0
===============================
First Official Release

=====================================================================================================================*/
