//=============================================================================
// Copyright (C) 2023, Qorvo, Inc.
//
// THIS SOFTWARE IS SUBJECT TO A SOURCE CODE LICENSE AGREEMENT WHICH PROVIDES,
// AMONG OTHER THINGS:  (i) THAT IT CAN BE USED ONLY TO ADAPT THE LICENSEE'S
// APPLICATION TO PAC PROCESSORS SUPPLIED BY QORVO, INC.;
// (ii) THAT  IT IS PROVIDED "AS IS" WITHOUT WARRANTY;  (iii) THAT
// QORVO, INC. IS NOT LIABLE FOR ANY INDIRECT DAMAGES OR FOR DIRECT
// DAMAGES EXCEEDING US$1,500;  AND (iv) THAT IT CAN BE DISCLOSED TO AND USED
// ONLY BY CERTAIN AUTHORIZED PERSONS.
//
//=============================================================================
 
#include "app.h"

//===============================================================================================================================
// PAC25140 devices contain an Battery Over-Voltage Protection(BATOV)
// This app shows the basic configure of BATOV
//===============================================================================================================================
void pac_batov_test(void)
{
    __disable_irq();

    system_init();
    uart_init(UARTC, 115200);
    pac_batov_init();
    printf("BATOV test\n");

    __enable_irq();

    printf("Turn on DSG and CHG\n");
		PAC_GPIOB->OUT.P0 = 1;
		PAC_GPIOB->OUT.P1 = 1;

    while (1)
    {
        pac_batov_monitor();
        pac_delay_asm(1000000);
    }
}
