//=============================================================================
// Copyright (C) 2023, Qorvo, Inc.
//
// THIS SOFTWARE IS SUBJECT TO A SOURCE CODE LICENSE AGREEMENT WHICH PROVIDES,
// AMONG OTHER THINGS:  (i) THAT IT CAN BE USED ONLY TO ADAPT THE LICENSEE'S
// APPLICATION TO PAC PROCESSORS SUPPLIED BY QORVO, INC.;
// (ii) THAT  IT IS PROVIDED "AS IS" WITHOUT WARRANTY;  (iii) THAT
// QORVO, INC. IS NOT LIABLE FOR ANY INDIRECT DAMAGES OR FOR DIRECT
// DAMAGES EXCEEDING US$1,500;  AND (iv) THAT IT CAN BE DISCLOSED TO AND USED
// ONLY BY CERTAIN AUTHORIZED PERSONS.
//
//=============================================================================
 
#include "app.h"
#include "pac_afe_wwdt.h"

//===============================================================================================================================
// PAC25140 devices contain a AFE windowed watch dog timer(AFE_WWDT).
// This app shows the basic functionality of the AFE_WWDT module in reset mode.
//     To write to the AFE_WWDT registers, the SOC.WWDTCTL.KEY reg must be written with 0x14
//     The AFE_WWDT can be configured to reset the system when the counter reaches 0.
//     Reset Mode:
//          If the AFE_WWDT is cleared before the counter is less than the WINDOW value, it will reset the device.
//          If the AFE_WWDT is not cleared before it counts down to 0, it will reset the device.
//===============================================================================================================================
void pac_afe_wwdt_test(void)
{
    __disable_irq();

    system_init();
    uart_init(UARTC, 115200);
    pac_afe_wwdt_init();
    printf("AFE_WWDT test\n");

    __enable_irq();

    afe_watchdog_enable(1);
    while (1)
    {
        pac_delay_asm(100000000);
        printf("Feed the dog...\n");
        afe_watchdog_reset();
			
	}
}
