/**
 * @file 	pac_iadc_conversion.h
 * @version v1.0.0
 * @date	14 October 2022
 * @brief 
 */

//=============================================================================
// Copyright (C) 2023, Qorvo, Inc.
//
// THIS SOFTWARE IS SUBJECT TO A SOURCE CODE LICENSE AGREEMENT WHICH PROVIDES,
// AMONG OTHER THINGS:  (i) THAT IT CAN BE USED ONLY TO ADAPT THE LICENSEE'S
// APPLICATION TO PAC PROCESSORS SUPPLIED BY QORVO, INC.;
// (ii) THAT  IT IS PROVIDED "AS IS" WITHOUT WARRANTY;  (iii) THAT
// QORVO, INC. IS NOT LIABLE FOR ANY INDIRECT DAMAGES OR FOR DIRECT
// DAMAGES EXCEEDING US$1,500;  AND (iv) THAT IT CAN BE DISCLOSED TO AND USED
// ONLY BY CERTAIN AUTHORIZED PERSONS.
//
//=============================================================================

#ifndef _PAC_IADC_CONVERSION_H
#define _PAC_IADC_CONVERSION_H

#include "app.h"

#define CAL_VB01_INFO_ADDR                          0x00100460
#define CAL_VB02_INFO_ADDR                          0x00100464
#define CAL_VB03_INFO_ADDR                          0x00100468
#define CAL_VB04_INFO_ADDR                          0x0010046C
#define CAL_VB05_INFO_ADDR                          0x00100470
#define CAL_VB06_INFO_ADDR                          0x00100474
#define CAL_VB07_INFO_ADDR                          0x00100478
#define CAL_VB08_INFO_ADDR                          0x0010047C
#define CAL_VB09_INFO_ADDR                          0x00100480
#define CAL_VB10_INFO_ADDR                          0x00100484
#define CAL_VB11_INFO_ADDR                          0x00100488
#define CAL_VB12_INFO_ADDR                          0x0010048C
#define CAL_VB13_INFO_ADDR                          0x00100490
#define CAL_VB14_INFO_ADDR                          0x00100494
#define CAL_VB15_INFO_ADDR                          0x00100498
#define CAL_VB16_INFO_ADDR                          0x0010049C
#define CAL_VB17_INFO_ADDR                          0x001004A0
#define CAL_VB18_INFO_ADDR                          0x001004A4
#define CAL_VB19_INFO_ADDR                          0x001004A8
#define CAL_VB20_INFO_ADDR                          0x001004AC
#define CAL_IADC_1X_GAIN_INFO_ADDR                  0x001004B0
#define CAL_IADC_1X_OFFSET_INFO_ADDR                0x001004B4
#define CAL_IADC_2X_GAIN_INFO_ADDR                  0x001004B8
#define CAL_IADC_2X_OFFSET_INFO_ADDR                0x001004BC
#define CAL_IADC_4X_GAIN_INFO_ADDR                  0x001004C0
#define CAL_IADC_4X_OFFSET_INFO_ADDR                0x001004C4
#define CAL_IADC_8X_GAIN_INFO_ADDR                  0x001004C8
#define CAL_IADC_8X_OFFSET_INFO_ADDR                0x001004CC
#define CAL_IADC_16X_GAIN_INFO_ADDR                 0x001004D0
#define CAL_IADC_16X_OFFSET_INFO_ADDR               0x001004D4
#define CAL_IADC_32X_GAIN_INFO_ADDR                 0x001004D8
#define CAL_IADC_32X_OFFSET_INFO_ADDR               0x001004DC
#define CAL_IADC_64X_GAIN_INFO_ADDR                 0x001004E0
#define CAL_IADC_64X_OFFSET_INFO_ADDR               0x001004E4
#define CAL_IADC_128X_GAIN_INFO_ADDR                0x001004E8
#define CAL_IADC_128X_OFFSET_INFO_ADDR              0x001004EC

#define ONE_DIV_2_POWER_15F         (1.0f / (1ull << 15))
#define ONE_DIV_2_POWER_16F         (1.0f / (1ull << 16))
#define ONE_DIV_2_POWER_17F         (1.0f / (1ull << 17))
#define ONE_DIV_2_POWER_18F         (1.0f / (1ull << 18))
#define ONE_DIV_2_POWER_19F         (1.0f / (1ull << 19))
#define ONE_DIV_2_POWER_20F         (1.0f / (1ull << 20))
#define ONE_DIV_2_POWER_21F         (1.0f / (1ull << 21))
#define ONE_DIV_2_POWER_22F         (1.0f / (1ull << 22))
#define ONE_DIV_2_POWER_23F         (1.0f / (1ull << 23))
#define ONE_DIV_2_POWER_24F         (1.0f / (1ull << 24))
#define ONE_DIV_2_POWER_25F         (1.0f / (1ull << 25))
#define ONE_DIV_2_POWER_26F         (1.0f / (1ull << 26))
#define ONE_DIV_2_POWER_27F         (1.0f / (1ull << 27))
#define ONE_DIV_2_POWER_28F         (1.0f / (1ull << 28))
#define ONE_DIV_2_POWER_29F         (1.0f / (1ull << 29))
#define ONE_DIV_2_POWER_30F         (1.0f / (1ull << 30))
#define ONE_DIV_2_POWER_31F         (1.0f / (1ull << 31))
#define ONE_DIV_2_POWER_32F         (1.0f / (1ull << 32))
#define ONE_DIV_2_POWER_33F         (1.0f / (1ull << 33))
#define ONE_DIV_2_POWER_34F         (1.0f / (1ull << 34))
#define ONE_DIV_2_POWER_35F         (1.0f / (1ull << 35))
#define ONE_DIV_2_POWER_36F         (1.0f / (1ull << 36))
#define ONE_DIV_2_POWER_37F         (1.0f / (1ull << 37))
#define ONE_DIV_2_POWER_38F         (1.0f / (1ull << 38)) 

#define DA_GAIN_1X                  0
#define DA_GAIN_2X                  1
#define DA_GAIN_4X                  2
#define DA_GAIN_8X                  3
#define DA_GAIN_16X                 4
#define DA_GAIN_32X                 5
#define DA_GAIN_64X                 6
#define DA_GAIN_128X                7

#define DA_GAIN                     DA_GAIN_128X

#if (DA_GAIN == DA_GAIN_1X)
    #define IADCCTL_DAGAIN                      IADCCTL_DAGAIN_1
    #define IADC_GAIN_INFO_ADDR                 CAL_IADC_1X_GAIN_INFO_ADDR
    #define IADC_OFFSET_INFO_ADDR               CAL_IADC_1X_OFFSET_INFO_ADDR
    #define IADC_GAIN_FACTOR                    ONE_DIV_2_POWER_31F
    #define IADC_OFFSET_FACTOR                  ONE_DIV_2_POWER_15F
#elif (DA_GAIN == DA_GAIN_2X)
    #define IADCCTL_DAGAIN                      IADCCTL_DAGAIN_2
    #define IADC_GAIN_INFO_ADDR                 CAL_IADC_2X_GAIN_INFO_ADDR
    #define IADC_OFFSET_INFO_ADDR               CAL_IADC_2X_OFFSET_INFO_ADDR
    #define IADC_GAIN_FACTOR                    ONE_DIV_2_POWER_32F
    #define IADC_OFFSET_FACTOR                  ONE_DIV_2_POWER_16F
#elif (DA_GAIN == DA_GAIN_4X)
    #define IADCCTL_DAGAIN                      IADCCTL_DAGAIN_4
    #define IADC_GAIN_INFO_ADDR                 CAL_IADC_4X_GAIN_INFO_ADDR
    #define IADC_OFFSET_INFO_ADDR               CAL_IADC_4X_OFFSET_INFO_ADDR
    #define IADC_GAIN_FACTOR                    ONE_DIV_2_POWER_33F
    #define IADC_OFFSET_FACTOR                  ONE_DIV_2_POWER_17F
#elif (DA_GAIN == DA_GAIN_8X)
    #define IADCCTL_DAGAIN                      IADCCTL_DAGAIN_8
    #define IADC_GAIN_INFO_ADDR                 CAL_IADC_8X_GAIN_INFO_ADDR
    #define IADC_OFFSET_INFO_ADDR               CAL_IADC_8X_OFFSET_INFO_ADDR
    #define IADC_GAIN_FACTOR                    ONE_DIV_2_POWER_34F
    #define IADC_OFFSET_FACTOR                  ONE_DIV_2_POWER_18F
#elif (DA_GAIN == DA_GAIN_16X)
    #define IADCCTL_DAGAIN                      IADCCTL_DAGAIN_16
    #define IADC_GAIN_INFO_ADDR                 CAL_IADC_16X_GAIN_INFO_ADDR
    #define IADC_OFFSET_INFO_ADDR               CAL_IADC_16X_OFFSET_INFO_ADDR
    #define IADC_GAIN_FACTOR                    ONE_DIV_2_POWER_35F
    #define IADC_OFFSET_FACTOR                  ONE_DIV_2_POWER_19F
#elif (DA_GAIN == DA_GAIN_32X)
    #define IADCCTL_DAGAIN                      IADCCTL_DAGAIN_32
    #define IADC_GAIN_INFO_ADDR                 CAL_IADC_32X_GAIN_INFO_ADDR
    #define IADC_OFFSET_INFO_ADDR               CAL_IADC_32X_OFFSET_INFO_ADDR
    #define IADC_GAIN_FACTOR                    ONE_DIV_2_POWER_36F
    #define IADC_OFFSET_FACTOR                  ONE_DIV_2_POWER_20F
#elif (DA_GAIN == DA_GAIN_64X)
    #define IADCCTL_DAGAIN                      IADCCTL_DAGAIN_64
    #define IADC_GAIN_INFO_ADDR                 CAL_IADC_64X_GAIN_INFO_ADDR
    #define IADC_OFFSET_INFO_ADDR               CAL_IADC_64X_OFFSET_INFO_ADDR
    #define IADC_GAIN_FACTOR                    ONE_DIV_2_POWER_37F
    #define IADC_OFFSET_FACTOR                  ONE_DIV_2_POWER_21F
#elif (DA_GAIN == DA_GAIN_128X)
    #define IADCCTL_DAGAIN                      IADCCTL_DAGAIN_128
    #define IADC_GAIN_INFO_ADDR                 CAL_IADC_128X_GAIN_INFO_ADDR
    #define IADC_OFFSET_INFO_ADDR               CAL_IADC_128X_OFFSET_INFO_ADDR
    #define IADC_GAIN_FACTOR                    ONE_DIV_2_POWER_38F
    #define IADC_OFFSET_FACTOR                  ONE_DIV_2_POWER_22F
#else
    #error "Invalid DA_GAIN"
#endif

#define SHUNT_RESISTOR_OHMS                     0.0005f

extern void pac_iadc_conversion_init(void);
extern void pac_iadc_conversion(void);

#endif
