/**
 * @file 	pac_vadc_conversion.h
 * @version v1.0.0
 * @date	14 October 2022
 * @brief 
 */

//=============================================================================
// Copyright (C) 2023, Qorvo, Inc.
//
// THIS SOFTWARE IS SUBJECT TO A SOURCE CODE LICENSE AGREEMENT WHICH PROVIDES,
// AMONG OTHER THINGS:  (i) THAT IT CAN BE USED ONLY TO ADAPT THE LICENSEE'S
// APPLICATION TO PAC PROCESSORS SUPPLIED BY QORVO, INC.;
// (ii) THAT  IT IS PROVIDED "AS IS" WITHOUT WARRANTY;  (iii) THAT
// QORVO, INC. IS NOT LIABLE FOR ANY INDIRECT DAMAGES OR FOR DIRECT
// DAMAGES EXCEEDING US$1,500;  AND (iv) THAT IT CAN BE DISCLOSED TO AND USED
// ONLY BY CERTAIN AUTHORIZED PERSONS.
//
//=============================================================================

#ifndef _PAC_VADC_CONVERSION_H
#define _PAC_VADC_CONVERSION_H

#include "app.h"

#define CAL_VB01_INFO_ADDR                          0x00100460
#define CAL_VB02_INFO_ADDR                          0x00100464
#define CAL_VB03_INFO_ADDR                          0x00100468
#define CAL_VB04_INFO_ADDR                          0x0010046C
#define CAL_VB05_INFO_ADDR                          0x00100470
#define CAL_VB06_INFO_ADDR                          0x00100474
#define CAL_VB07_INFO_ADDR                          0x00100478
#define CAL_VB08_INFO_ADDR                          0x0010047C
#define CAL_VB09_INFO_ADDR                          0x00100480
#define CAL_VB10_INFO_ADDR                          0x00100484
#define CAL_VB11_INFO_ADDR                          0x00100488
#define CAL_VB12_INFO_ADDR                          0x0010048C
#define CAL_VB13_INFO_ADDR                          0x00100490
#define CAL_VB14_INFO_ADDR                          0x00100494
#define CAL_VB15_INFO_ADDR                          0x00100498
#define CAL_VB16_INFO_ADDR                          0x0010049C
#define CAL_VB17_INFO_ADDR                          0x001004A0
#define CAL_VB18_INFO_ADDR                          0x001004A4
#define CAL_VB19_INFO_ADDR                          0x001004A8
#define CAL_VB20_INFO_ADDR                          0x001004AC
#define CAL_IADC_1X_GAIN_INFO_ADDR                  0x001004B0
#define CAL_IADC_1X_OFFSET_INFO_ADDR                0x001004B4
#define CAL_IADC_2X_GAIN_INFO_ADDR                  0x001004B8
#define CAL_IADC_2X_OFFSET_INFO_ADDR                0x001004BC
#define CAL_IADC_4X_GAIN_INFO_ADDR                  0x001004C0
#define CAL_IADC_4X_OFFSET_INFO_ADDR                0x001004C4
#define CAL_IADC_8X_GAIN_INFO_ADDR                  0x001004C8
#define CAL_IADC_8X_OFFSET_INFO_ADDR                0x001004CC
#define CAL_IADC_16X_GAIN_INFO_ADDR                 0x001004D0
#define CAL_IADC_16X_OFFSET_INFO_ADDR               0x001004D4
#define CAL_IADC_32X_GAIN_INFO_ADDR                 0x001004D8
#define CAL_IADC_32X_OFFSET_INFO_ADDR               0x001004DC
#define CAL_IADC_64X_GAIN_INFO_ADDR                 0x001004E0
#define CAL_IADC_64X_OFFSET_INFO_ADDR               0x001004E4
#define CAL_IADC_128X_GAIN_INFO_ADDR                0x001004E8
#define CAL_IADC_128X_OFFSET_INFO_ADDR              0x001004EC

#define ONE_DIV_2_POWER_15F         (1.0f / (1ull << 15))
#define ONE_DIV_2_POWER_28F         (1.0f / (1ull << 28))

extern void pac_vadc_conversion_init(void);
extern void pac_vadc_conversion(void);

#endif
