//=============================================================================
// Copyright (C) 2023, Qorvo, Inc.
//
// THIS SOFTWARE IS SUBJECT TO A SOURCE CODE LICENSE AGREEMENT WHICH PROVIDES,
// AMONG OTHER THINGS:  (i) THAT IT CAN BE USED ONLY TO ADAPT THE LICENSEE'S
// APPLICATION TO PAC PROCESSORS SUPPLIED BY QORVO, INC.;
// (ii) THAT  IT IS PROVIDED "AS IS" WITHOUT WARRANTY;  (iii) THAT
// QORVO, INC. IS NOT LIABLE FOR ANY INDIRECT DAMAGES OR FOR DIRECT
// DAMAGES EXCEEDING US$1,500;  AND (iv) THAT IT CAN BE DISCLOSED TO AND USED
// ONLY BY CERTAIN AUTHORIZED PERSONS.
//
//=============================================================================
 
#include "app.h"

//===============================================================================================================================
// The PAC25140 also contains a 16-bit Sigma-Delta ADC that may be used for voltage sensing for the individual cells(vadc). 
// There is a MUX that selects each of the individual cell balance nodes (VB1 to VB20) so that they may be sampled by the 16-bit ADC.
// This app shows the basic configure of vadc 
//===============================================================================================================================
void pac_vadc_conversion_test(void)
{
    __disable_irq();

    system_init();
    uart_init(UARTC, 115200);
    pac_vadc_conversion_init();
    printf("VADC conversion test\n");

    __enable_irq();

    while (1)
    {
        pac_vadc_conversion();
        pac_delay_asm(1000000);
    }
}
