//=============================================================================
// Copyright (C) 2023, Qorvo, Inc.
//
// THIS SOFTWARE IS SUBJECT TO A SOURCE CODE LICENSE AGREEMENT WHICH PROVIDES,
// AMONG OTHER THINGS:  (i) THAT IT CAN BE USED ONLY TO ADAPT THE LICENSEE'S
// APPLICATION TO PAC PROCESSORS SUPPLIED BY QORVO, INC.;
// (ii) THAT  IT IS PROVIDED "AS IS" WITHOUT WARRANTY;  (iii) THAT
// QORVO, INC. IS NOT LIABLE FOR ANY INDIRECT DAMAGES OR FOR DIRECT
// DAMAGES EXCEEDING US$1,500;  AND (iv) THAT IT CAN BE DISCLOSED TO AND USED
// ONLY BY CERTAIN AUTHORIZED PERSONS.
//
//=============================================================================
 
#include "app.h"
                              /*master_tx, slave_tx*/
volatile uint16_t ssp_data[9][2] = {{0x00, 0x10},
                                    {0x01, 0x20},
                                    {0x02, 0x30},
                                    {0x03, 0x40},
                                    {0x04, 0x50},
                                    {0x05, 0x60},
                                    {0x06, 0x70},
                                    {0x07, 0x80},
                                    {0x08, 0x90}};
volatile uint16_t ssp_data_rx;
volatile uint16_t data_num;
volatile uint8_t ssp_isr_flag;

#ifdef DF_isr_for_SSP

//==============================================================================
///@brief
///     SSPA interrupt
///
///@param[in]
///     None
///
///@param[out]
///     None
///
///@retval
///     None
///
//==============================================================================
void USARTA_IRQHandler(void)
{
//    // SSP A IRQ -- TX FIFO
//    if (PAC_SSPA->MIS.TXMIS)
//    {
//    }

//    // SSP A IRQ -- RX FIFO
//    if (PAC_SSPA->MIS.RXMIS)
//    {
//    }
    
//    // SSP A IRQ -- RX Overrun
//    if (PAC_SSPA->MIS.ROMIS)
//    {
//        PAC_SSPA->ICLR.ROIC = 1;              // Clear RX Overrun interrupt
//    }
    
    // SSP A IRQ -- RX FIFO timeout
    if (PAC_SSPA->MIS.RTMIS)
    {
        PAC_SSPA->ICLR.RTIC = 1;                 // Clear RX Overrun interrupt
        
//        #ifdef TEST_SSP_MASTER
        while (PAC_SSPA->STAT.RNE == 1)
        {
            ssp_data_rx = PAC_SSPA->DAT.DATA;
            ssp_isr_flag = 1;
        }
//        #endif
        
//        #ifdef TEST_SSP_SLAVE    
//        while (PAC_SSPA->STAT.RNE == 1)
//        {
//            volatile uint16_t data_read;
//            
//            ssp_data_rx = PAC_SSPA->DAT.DATA;
//            
//            PAC_SSPA->DAT.DATA = ssp_data[ssp_data_rx][1];
//            
//            // Wait for transmission to be complete
//            while (!PAC_SSPA->STAT.TNF);
//      
//            data_read = PAC_SSPA->DAT.DATA;      // Read receive buffer data
//            
//            (void) data_read;                        // Added to prevent compiler warnings about the variable being set but not unused            
//            ssp_isr_flag = 1;
//        }        
//        #endif
    }    

    NVIC_ClearPendingIRQ(USARTA_IRQn);
}

//==============================================================================
///@brief
///     SSPB interrupt
///
///@param[in]
///     None
///
///@param[out]
///     None
///
///@retval
///     None
///
//==============================================================================
void USARTB_IRQHandler(void)
{
//    // SSP B IRQ -- TX FIFO
//    if (PAC_SSPB->MIS.TXMIS)
//    {
//    }

//    // SSP B IRQ -- RX FIFO
//    if (PAC_SSPB->MIS.RXMIS)
//    {
//    }
    
//    // SSP B IRQ -- RX Overrun
//    if (PAC_SSPB->MIS.ROMIS)
//    {
//        PAC_SSPB->ICLR.ROIC = 1;              // Clear RX Overrun interrupt
//    }
    
    // SSP B IRQ -- RX FIFO timeout
    if (PAC_SSPB->MIS.RTMIS)
    {
        PAC_SSPB->ICLR.RTIC = 1;                 // Clear RX Overrun interrupt
        
//        #ifdef TEST_SSP_MASTER
        while (PAC_SSPB->STAT.RNE == 1)
        {
            ssp_data_rx = PAC_SSPB->DAT.DATA;
            ssp_isr_flag = 1;
        }
//        #endif
        
//        #ifdef TEST_SSP_SLAVE    
//        while (PAC_SSPB->STAT.RNE == 1)
//        {
//            volatile uint16_t data_read;
//            
//            ssp_data_rx = PAC_SSPB->DAT.DATA;
//            
//            PAC_SSPB->DAT.DATA = ssp_data[ssp_data_rx][1];
//            
//            // Wait for transmission to be complete
//            while (!PAC_SSPB->STAT.TNF);
//      
//            data_read = PAC_SSPB->DAT.DATA;      // Read receive buffer data
//            
//            (void) data_read;                        // Added to prevent compiler warnings about the variable being set but not unused            
//            ssp_isr_flag = 1;
//        }        
//        #endif
    }    
    NVIC_ClearPendingIRQ(USARTB_IRQn);
}

//==============================================================================
///@brief
///     SSPC interrupt
///
///@param[in]
///     None
///
///@param[out]
///     None
///
///@retval
///     None
///
//==============================================================================
void USARTC_IRQHandler(void)
{
//    // SSP C IRQ -- TX FIFO
//    if (PAC_SSPC->MIS.TXMIS)
//    {
//    }

//    // SSP C IRQ -- RX FIFO
//    if (PAC_SSPC->MIS.RXMIS)
//    {
//    }
    
//    // SSP C IRQ -- RX Overrun
//    if (PAC_SSPC->MIS.ROMIS)
//    {
//        PAC_SSPC->ICLR.ROIC = 1;              // Clear RX Overrun interrupt
//    }
    
    // SSP C IRQ -- RX FIFO timeout
    if (PAC_SSPC->MIS.RTMIS)
    {
        PAC_SSPC->ICLR.RTIC = 1;                 // Clear RX Overrun interrupt
        
//        #ifdef TEST_SSP_MASTER
        while (PAC_SSPC->STAT.RNE == 1)
        {
            ssp_data_rx = PAC_SSPC->DAT.DATA;
            ssp_isr_flag = 1;
        }
//        #endif
        
//        #ifdef TEST_SSP_SLAVE    
//        while (PAC_SSPC->STAT.RNE == 1)
//        {
//            volatile uint16_t data_read;
//            
//            ssp_data_rx = PAC_SSPC->DAT.DATA;
//            
//            PAC_SSPC->DAT.DATA = ssp_data[ssp_data_rx][1];
//            
//            // Wait for transmission to be complete
//            while (!PAC_SSPC->STAT.TNF);
//      
//            data_read = PAC_SSPC->DAT.DATA;      // Read receive buffer data
//            
//            (void) data_read;                        // Added to prevent compiler warnings about the variable being set but not unused            
//            ssp_isr_flag = 1;
//        }        
//        #endif
    }    
    NVIC_ClearPendingIRQ(USARTC_IRQn);
}

//==============================================================================
///@brief
///     SSPD interrupt
///
///@param[in]
///     None
///
///@param[out]
///     None
///
///@retval
///     None
///
//==============================================================================
void USARTD_IRQHandler(void)
{
//    // SSP D IRQ -- TX FIFO
//    if (PAC_SSPD->MIS.TXMIS)
//    {
//    }

//    // SSP D IRQ -- RX FIFO
//    if (PAC_SSPD->MIS.RXMIS)
//    {
//    }
    
//    // SSP D IRQ -- RX Overrun
//    if (PAC_SSPD->MIS.ROMIS)
//    {
//        PAC_SSPD->ICLR.ROIC = 1;              // Clear RX Overrun interrupt
//    }
    
    // SSP D IRQ -- RX FIFO timeout
    if (PAC_SSPD->MIS.RTMIS)
    {
        PAC_SSPD->ICLR.RTIC = 1;                 // Clear RX Overrun interrupt
        
//       #ifdef TEST_SSP_MASTER
        while (PAC_SSPD->STAT.RNE == 1)
        {
            ssp_data_rx = PAC_SSPD->DAT.DATA;
            ssp_isr_flag = 1;
        }
//       #endif
        
//        #ifdef TEST_SSP_SLAVE    
//        while (PAC_SSPD->STAT.RNE == 1)
//        {
//            volatile uint16_t data_read;
//            
//            ssp_data_rx = PAC_SSPD->DAT.DATA;
//            
//            PAC_SSPD->DAT.DATA = ssp_data[ssp_data_rx][1];
//            
//            // Wait for transmission to be complete
//            while (!PAC_SSPD->STAT.TNF);
//      
//            data_read = PAC_SSPD->DAT.DATA;      // Read receive buffer data
//            
//            (void) data_read;                        // Added to prevent compiler warnings about the variable being set but not unused            
//            ssp_isr_flag = 1;
//        }        
//        #endif
    }    
    NVIC_ClearPendingIRQ(USARTD_IRQn);
}
#endif
