//=============================================================================
// Copyright (C) 2023, Qorvo, Inc.
//
// THIS SOFTWARE IS SUBJECT TO A SOURCE CODE LICENSE AGREEMENT WHICH PROVIDES,
// AMONG OTHER THINGS:  (i) THAT IT CAN BE USED ONLY TO ADAPT THE LICENSEE'S
// APPLICATION TO PAC PROCESSORS SUPPLIED BY QORVO, INC.;
// (ii) THAT  IT IS PROVIDED "AS IS" WITHOUT WARRANTY;  (iii) THAT
// QORVO, INC. IS NOT LIABLE FOR ANY INDIRECT DAMAGES OR FOR DIRECT
// DAMAGES EXCEEDING US$1,500;  AND (iv) THAT IT CAN BE DISCLOSED TO AND USED
// ONLY BY CERTAIN AUTHORIZED PERSONS.
//
//=============================================================================

#include "app.h"

PAC_RAMFUNC void CAN_IRQHandler(void)
{
    uint32_t buffer;
    static Struct_CAN* can_ptr = &User_CAN;
    buffer = PAC_CAN->RXBUF;    //  read RX buffer, RX buffer bit order same as TX buffer 

    if(buffer&0x80)    // Extended Frame
    {
        id_frame_format = 1;
        
        can_ptr->e_receive.m1 = buffer;
        buffer = PAC_CAN->RXBUF;
        can_ptr->e_receive.m2 = buffer;        
        rx_dataLen = can_ptr->e_receive.dlc;
        rx_id_e = (can_ptr->e_receive.id00to04) + (can_ptr->e_receive.id05to12<<5) + (can_ptr->e_receive.id13to20<<13)  + (can_ptr->e_receive.id21to28<<21); 

        rx_data[0] = can_ptr->e_receive.data1;
        rx_data[1] = can_ptr->e_receive.data2;
        rx_data[2] = can_ptr->e_receive.data3;    
        if(rx_dataLen > 3)
        {
            buffer = PAC_CAN->RXBUF;
            can_ptr->e_receive.m3 = buffer;    
            rx_data[3] = can_ptr->e_receive.data4;    
            rx_data[4] = can_ptr->e_receive.data5;    
            rx_data[5] = can_ptr->e_receive.data6;    
            rx_data[6] = can_ptr->e_receive.data7;    
            if(rx_dataLen > 7)
            {
                buffer = PAC_CAN->RXBUF;
                can_ptr->e_receive.m4 = buffer;                
                rx_data[7] = can_ptr->e_receive.data8;
            }                
        }
    }
    else            // Standard Frame
    {
        id_frame_format = 0;
        
        can_ptr->s_receive.m1 = buffer;
        
        rx_dataLen = can_ptr->s_receive.dlc;
        rx_id_s = (can_ptr->s_receive.id00to02) + (can_ptr->s_receive.id03to10<<3);     
        
        rx_data[0] = can_ptr->s_receive.data1;        
        if(rx_dataLen > 1)
        {
            buffer = PAC_CAN->RXBUF;
            can_ptr->s_receive.m2 = buffer;    
            rx_data[1] = can_ptr->s_receive.data2;
            rx_data[2] = can_ptr->s_receive.data3;
            rx_data[3] = can_ptr->s_receive.data4;    
            rx_data[4] = can_ptr->s_receive.data5;
            if(rx_dataLen > 5)
            {
                buffer = PAC_CAN->RXBUF;
                can_ptr->s_receive.m3 = buffer;                        
                rx_data[5] = can_ptr->s_receive.data6;
                rx_data[6] = can_ptr->s_receive.data7;
                rx_data[7] = can_ptr->s_receive.data8;
            }
        }            
    }
    rx_flag = 1;
    PAC_CAN->ISR_SR_CMR_MR = (PAC_CAN->ISR_SR_CMR_MR & 0x00FFFFFF) | ISR_RI; // Clear RX interrupt
}
