//=============================================================================
// Copyright (C) 2023, Qorvo, Inc.
//
// THIS SOFTWARE IS SUBJECT TO A SOURCE CODE LICENSE AGREEMENT WHICH PROVIDES,
// AMONG OTHER THINGS:  (i) THAT IT CAN BE USED ONLY TO ADAPT THE LICENSEE'S
// APPLICATION TO PAC PROCESSORS SUPPLIED BY QORVO, INC.;
// (ii) THAT  IT IS PROVIDED "AS IS" WITHOUT WARRANTY;  (iii) THAT
// QORVO, INC. IS NOT LIABLE FOR ANY INDIRECT DAMAGES OR FOR DIRECT
// DAMAGES EXCEEDING US$1,500;  AND (iv) THAT IT CAN BE DISCLOSED TO AND USED
// ONLY BY CERTAIN AUTHORIZED PERSONS.
//
//=============================================================================

#include "app.h"

//===============================================================================================================================
// This app shows the basic function of GPIO operation: Output and interrupt input
//     PE0/1 pin is output with a delay
//     PD5 is set as an interrupt input and when PC7 reaches GND, it will go to the gpio_isr.c to reverse the PE0 pin
//===============================================================================================================================
void gpio_app(void)
{
    uint8_t input;
    // Disable global interrupts until initialization is complete
    __disable_irq();
    system_init();
    uart_init(UARTC, 115200);
    //-----------------------test gpio-----------------------------
    printf("\r\n --------------- GPIO_test ---------------");
    GPIO_output();                      // PE0/PE1 output
    GPIO_input();                       // PD5 input
    // Enable global interrupts
    __enable_irq();

    while (1)
    {
        // PAC_GPIOE->OUT.P1 = 0;         // PE1 output Toggle setting
        // delay_times(100000);
        // PAC_GPIOE->OUT.P1 = 1;         // PE1 output Toggle setting

        delay_times(50000);
        PAC_GPIOE->OUT.P1 ^= 1;         // PE1 output Toggle setting

        input = PAC_GPIOD->IN.P5;       // Read input level; default value is 0
        printf("\r\n    PD5 PORT INPUT = %d", input);

        if (PAC_GPIOD->IN.P5)           // PD5 INPUT HIGH ?
        {
            printf("\r\n    PE0 PORT OUTPUT = HIGH");
        }
        else
        {
            printf("\r\n    PE0 PORT OUTPUT = LOW");
        }
    }
}
