//=============================================================================
// Copyright (C) 2023, Qorvo, Inc.
//
// THIS SOFTWARE IS SUBJECT TO A SOURCE CODE LICENSE AGREEMENT WHICH PROVIDES,
// AMONG OTHER THINGS:  (i) THAT IT CAN BE USED ONLY TO ADAPT THE LICENSEE'S
// APPLICATION TO PAC PROCESSORS SUPPLIED BY QORVO, INC.;
// (ii) THAT  IT IS PROVIDED "AS IS" WITHOUT WARRANTY;  (iii) THAT
// QORVO, INC. IS NOT LIABLE FOR ANY INDIRECT DAMAGES OR FOR DIRECT
// DAMAGES EXCEEDING US$1,500;  AND (iv) THAT IT CAN BE DISCLOSED TO AND USED
// ONLY BY CERTAIN AUTHORIZED PERSONS.
//
//=============================================================================

#include "app.h"

void GPIO_output(void)
{
    // PE0 Output setting
    PAC_SCC->PEMUXSEL.P0 = 0;                       // PE MUX select: PE0 GPIO default
    PAC_GPIOE->MODE.P0 = IO_PUSH_PULL_OUTPUT;       // PE Mode: PE0 Push-pull output
    PAC_GPIOE->OUTMASK.P0 = 0;                      // PE Output Data Mask setting: PE0 Not masked
    PAC_GPIOE->DOCLEAR.P0 = 1;                      // PE Data Output Clear: PE0 = 1
    PAC_GPIOE->DOSET.P0 = 1;                        // PE Data Output Set: PE0 = 1

    // PE1 Output setting
    PAC_SCC->PEMUXSEL.P1 = 0;                       // PE MUX select: PE1 GPIO default
    PAC_GPIOE->MODE.P1 = IO_PUSH_PULL_OUTPUT;       // PE Mode: PE1 = Push-pull output
    PAC_GPIOE->OUTMASK.P1 = 0;                      // PE Output Data Mask setting: PE1 Not masked
    PAC_GPIOE->DOCLEAR.P1 = 1;                      // PE Data Output Clear: PE1 = 1
    PAC_GPIOE->DOSET.P1 = 1;                        // PE Data Output Set: PE1 = 1
}

void GPIO_input(void)
{
    // PD5 Input setting
    PAC_SCC->PDMUXSEL.P5 = 0;                       // PD MUX select: PD5 GPIO default
    PAC_SCC->PDPUEN.P5 = 1;                         // PD Pull-up Enable: PD5 Enable
    PAC_GPIOD->MODE.P5 = IO_HIGH_IMPEDENCE_INPUT;   // PD Mode: PD5 High-impendance Input
    PAC_GPIOD->OUTMASK.P5 = 1;                      // PD Output Data Mask setting: PD5 Not masked

    // PD5 Interrupt setting
    PAC_GPIOD->INTTYPE.P5 = 0;                      // PD Interrupt Type: PD5 Edge triggered
    PAC_GPIOD->INTCFG.P5 = 1;                       // PD Interrupt Configuration: PD5 Trigger on falling edge
    PAC_GPIOD->INTEDGEBOTH.P5 = 1;                  // PD Interrupt Edge Both: PD5 Trigger on both rising and falling edge
    PAC_GPIOD->CLKSYNC.P5 = 1;                      // PD Clock Synchronization: PD5 Enable
    PAC_GPIOD->INTEN.P5 = 1;                        // PD Interrupt Enable: PD5 Enable
    PAC_GPIOD->INTCLEAR.P5 = 1;                     // PD Interrupt Clear: PD5 Clear GPIODINTFLAG.P5
    NVIC_SetPriority(GpioD_IRQn,1);                 // Interrupt Priority set, 0 is highest ,5 is lowest
    NVIC_EnableIRQ(GpioD_IRQn);                     // Enable interrupt
}

void gpiox_debug_init(void)
{
    PAC_GPIOD->MODE.P4 = IO_PUSH_PULL_OUTPUT;
    PAC_GPIOD->OUTMASK.P4 = 0;
    PAC_GPIOD->OUT.P4 = 0;
    
    PAC_GPIOE->MODE.P0 = IO_PUSH_PULL_OUTPUT;
    PAC_GPIOE->OUTMASK.P0 = 0;
    PAC_GPIOE->OUT.P0 = 0;
    
    PAC_GPIOE->MODE.P4 = IO_PUSH_PULL_OUTPUT;
    PAC_GPIOE->OUTMASK.P4 = 0;
    PAC_GPIOE->OUT.P4 = 0;
    
    PAC_SCC->PFMUXSEL.P3=  0;
    PAC_GPIOF->MODE.P3 = IO_PUSH_PULL_OUTPUT;
    PAC_GPIOF->OUTMASK.P3 = 0;
    PAC_GPIOF->OUT.P3 = 0;
}

