//=============================================================================
// Copyright (C) 2023, Qorvo, Inc.
//
// THIS SOFTWARE IS SUBJECT TO A SOURCE CODE LICENSE AGREEMENT WHICH PROVIDES,
// AMONG OTHER THINGS:  (i) THAT IT CAN BE USED ONLY TO ADAPT THE LICENSEE'S
// APPLICATION TO PAC PROCESSORS SUPPLIED BY QORVO, INC.;
// (ii) THAT  IT IS PROVIDED "AS IS" WITHOUT WARRANTY;  (iii) THAT
// QORVO, INC. IS NOT LIABLE FOR ANY INDIRECT DAMAGES OR FOR DIRECT
// DAMAGES EXCEEDING US$1,500;  AND (iv) THAT IT CAN BE DISCLOSED TO AND USED
// ONLY BY CERTAIN AUTHORIZED PERSONS.
//
//=============================================================================

#include "app.h"

PAC_RAMFUNC void GpioC_IRQHandler(void)
{
    PAC_GPIOE->OUT.P0 ^= 1;

    PAC_GPIOC->INTCLEAR.P7 = 1;
}


PAC_RAMFUNC void GpioD_IRQHandler(void)
{
	if(PAC_GPIOD->INTFLAG.P5)			    // Interrupt flag, If happen interrupt event default value is 0
	{
        if (PAC_GPIOD->IN.P5)               // PD5 INPUT HIGH ?
        {
            PAC_GPIOE->OUT.P0 = 1;          // PE0 OUTPUT HIGH
        }
        else
        {
            PAC_GPIOE->OUT.P0 = 0;          // PE0 OUTPUT HIGH
        }

		PAC_GPIOD->INTCLEAR.P5 = 1;		    // Interrupt flag clear, set 1 to clear interrupt flag default value is 0
	}
}

