//=============================================================================
// Copyright (C) 2023, Qorvo, Inc.
//
// THIS SOFTWARE IS SUBJECT TO A SOURCE CODE LICENSE AGREEMENT WHICH PROVIDES,
// AMONG OTHER THINGS:  (i) THAT IT CAN BE USED ONLY TO ADAPT THE LICENSEE'S
// APPLICATION TO PAC PROCESSORS SUPPLIED BY QORVO, INC.;
// (ii) THAT  IT IS PROVIDED "AS IS" WITHOUT WARRANTY;  (iii) THAT
// QORVO, INC. IS NOT LIABLE FOR ANY INDIRECT DAMAGES OR FOR DIRECT
// DAMAGES EXCEEDING US$1,500;  AND (iv) THAT IT CAN BE DISCLOSED TO AND USED
// ONLY BY CERTAIN AUTHORIZED PERSONS.
//
//=============================================================================

#include "app.h"

uint16_t low2high_capture_read_count_value, high2low_capture_read_count_value;

PAC_RAMFUNC void TimerA_IRQHandler(void)
{
	if (PAC_TIMERA->INT.CCR3IF)
	{
		//Do something
		PAC_GPIOE->OUT.P4 ^= 1; //toggle the pin to debug
		if (PAC_GPIOD->OUT.P2)
		{
			low2high_capture_read_count_value = PAC_TIMERA->CCTR3.w; //save the rising value
		}
		else
		{
			high2low_capture_read_count_value = PAC_TIMERA->CCTR3.w; //save the falling value
		}

		PAC_TIMERA->CTL.CLR = 1; //clear the timer
		PAC_TIMERA->CTL.CLR = 0; //reset the timer

		PAC_TIMERA->INT.CCR3IF = 1; //clear capture interrupt flag
	}
}

PAC_RAMFUNC void TimerB_IRQHandler(void)
{
    // TODO: Move to init code to clear CCR0IF the first time.
    if (PAC_TIMERB->INT.CCR0IF)
    {
        PAC_GPIOE->OUT.P0 ^= 1;
        // Clear TimerB Interrupt Flag
        PAC_TIMERB->INT.CCR0IF = 1;
    }

    if (PAC_TIMERB->INT.BASEIF)
    {
        // Clear TimerB Interrupt Flag
        PAC_TIMERB->INT.BASEIF = 1;
    }
}

PAC_RAMFUNC void TimerC_IRQHandler(void)
{
    // TODO: Move to init code to clear CCR0IF the first time.
    if (PAC_TIMERC->INT.CCR4IF)
    {
        PAC_TIMERC->INT.CCR4IF = 1;
    }
        
    // Clear TimerC Interrupt Flag
    if (PAC_TIMERC->INT.BASEIF)
    {
        PAC_TIMERC->INT.BASEIF = 1;
    }
}

PAC_RAMFUNC void TimerD_IRQHandler(void)
{
    // TODO: Move to init code to clear CCR0IF the first time.
    if (PAC_TIMERD->INT.CCR1IF)
    {
        PAC_TIMERD->INT.CCR1IF = 1;
    }
        
    // Clear TimerD Interrupt Flag
    if (PAC_TIMERD->INT.BASEIF)
    {
        peripheral.timer_d_interrupt_ticks++;

        if (peripheral.timer_d_interrupt_ticks >= 180)
        {
            peripheral.timer_d_interrupt_ticks = 0;
            
            if (peripheral.index_output == 0)
            {
                peripheral.index_output = 1;
                PAC_GPIOD->OUT.P4 = peripheral.index_output;                    //QEP index
            }
            else
            {
                peripheral.index_output = 0;
                PAC_GPIOD->OUT.P4 = peripheral.index_output;                    //QEP index
            }
       }
             
        PAC_TIMERD->INT.BASEIF = 1;
    }
}
