//=============================================================================
// Copyright (C) 2023, Qorvo, Inc.
//
// THIS SOFTWARE IS SUBJECT TO A SOURCE CODE LICENSE AGREEMENT WHICH PROVIDES,
// AMONG OTHER THINGS:  (i) THAT IT CAN BE USED ONLY TO ADAPT THE LICENSEE'S
// APPLICATION TO PAC PROCESSORS SUPPLIED BY QORVO, INC.;
// (ii) THAT  IT IS PROVIDED "AS IS" WITHOUT WARRANTY;  (iii) THAT
// QORVO, INC. IS NOT LIABLE FOR ANY INDIRECT DAMAGES OR FOR DIRECT
// DAMAGES EXCEEDING US$1,500;  AND (iv) THAT IT CAN BE DISCLOSED TO AND USED
// ONLY BY CERTAIN AUTHORIZED PERSONS.
//
//=============================================================================

#include "app.h"
#include "ramfunction.h"

void ramfunc_app(void)
{
    // Disable global interrupts until initialization is complete
    __disable_irq();
    system_init();
    uart_init(UARTC, 115200);
    // gpiox_debug_init();

    printf("\r\n--------------- RAMFUNC test ---------------\r\n");
    ramfunction_set();

    // Enable global interrupts
    __enable_irq();

    while (1)
    {

    }
}

PAC_RAMFUNC void ramfunction_set(void)
{
    printf("\r\nThis function was executed in RAM!");
    uint8_t a, b;
    a = 1;
    b = 2;
    printf("\r\nSet a = %d, b = %d.", a, b);
    printf("\r\na + b = %d", a + b);
}
